<?php
/**
* Часть кода по замене ссылок на безанкорные
*/

$maxUrlLength = 50; // Макс. длина ссылки без обрезки

$content = '...'; // Текст для обработки

$offset = 0;
while (($ps = mb_strpos($content, '<a ', $offset, 'utf-8')) !== false) {
	$pe = mb_strpos($content, '>', $ps, 'utf-8');

	$a = mb_substr($content, $ps, $pe + 1 - $ps, 'utf-8');
	$ps2 = mb_strpos($a, 'href="', 0, 'utf-8');
	$pe2 = mb_strpos($a, '"', $ps2 + 6, 'utf-8');
	$href = mb_substr($a, $ps2 + 6, $pe2 - $ps2 - 6, 'utf-8');
	$url = str_replace('https://', '', $href);
	$url = str_replace('http://', '', $url);
	
	// Обрезка ссылки
	if (strlen($href) > $maxUrlLength) {
		$tps = strpos($url, '/');
		if ($tps !== false) {
			$url = substr($url, 0, $tps);
		}
		// $url - только домен
	} else {
		$url = 'http://'.$url;
		// $url - полный
	}
	$href = $url;

	$ps2 = mb_strpos($content, '</a>', $pe, 'utf-8');
	if ($ps2 === false) break;
	
	$anchor = mb_substr($content, $pe + 1, $ps2 - $pe - 1, 'utf-8');

	$content = str_replace('>'.$anchor.'<', '>'.$href.'<', $content);

	$offset = $ps2 + 4;
	if ($offset >= mb_strlen($content, 'utf-8')) break;
}

// $content - обновленный текст

